<?php
/**	
 *
 *	DEBUGGER CLASS
 *	Author: Paul Hamlington
 *	Purpose: Append all errors to a error.log file. 
 * 
 */

    /** [ SET NAMESPACE: MODULIZED DOCSAWAY ] */
    namespace modulized_docsaway;
	

    /** [ DEBUGGER CLASS ] */
    class debugger
        {
        
		
	    /** --------------------------> CLASS INTERFACE METHODS <--------------------------*/
		
        
	    /** [ METHOD: STATIC ] */
        public static function err($err,$file,$class,$method,$line){self::errFunc($err,$file,$class,$method,$line);}

        
	    /** --------------------------> CLASS FUNCTIONALITY METHODS <--------------------------*/
		

        /** [ METHOD: ERROR ] */
        private static function errFunc($err,$file,$class,$method,$line)
            {
            /** [ STORE: PROPERTIES ] */
            $file=(!empty($file) ? $file : 'noFile');
            $class=(!empty($class) ? $class : 'noClass');
            $method=(!empty($method) ? $method : 'noMethod');
            $line=(!empty($line) ? $line : 'noLine');
      
            /** [ CONSTRUCT: ERROR MESSAGE ] */
            $errMessage="[ ".date("d/m/Y h:i:s")." ]\n".
                        "-- ERROR: ".$err."\n".
                        "-- PAGE: ".$file."\n".
                        "-- CLASS: ".$class."\n".
                        "-- METHOD: ".$method."\n".
                        "-- LINE: ".$line."\n\n";            
            
            /** [ ERROR WRITE FILE ] */	
            self::writeFile($errMessage);
            
            /** [ RETURN: BOOLEAN ] */
            unset($errMessage); return(true);
            }      
            
	    /** [ METHOD: WRITE FILE ] */
	    private static function writeFile($errMessage)
            {
            /** [ GENERATE FULL PATH ] */	
            $arr["path"]=globals::pluginPath();	
            $arr["pathFile"]=$arr["path"].'/error.log';
                    
            /** [ PATH EXISTANCE ] */
            if(!file_exists($arr["path"])){mkdir($arr["path"],0777,TRUE);}
					
            /** [ OPEN FILE ] */
            $arr["handler"]=fopen($arr["pathFile"],'a');
			
            /** [ CHANGE FILE PERMISSIONS ] */
            $arr["mask"]=umask(0);
            chmod($arr["pathFile"],0666);
            umask($arr["mask"]);	
			
            /** [ OUTPUT DATA ] */
            fwrite($arr["handler"],$errMessage); 
				
            /** [ CLOSE OBJECT ] */	
            fclose($arr["handler"]);
			
            /** [ RETURN: BOOLEAN ] */
            unset($arr); return(true);             
            }               
        }
?>