<?php
/**	
 *
 *	TEMPLATES CLASS
 *	Author: Paul Hamlington
 *	Purpose: Load HTML templates into PHP code. 
 * 
 */

    /** [ SET NAMESPACE: MODULIZED DOCSAWAY ] */
    namespace modulized_docsaway;	
	

    /** [ TEMPLATE CLASS ] */
    final class templates
        {
	    /** [ PRIVATE CLASS PROPERTIES ] */
	    private $globals;
		
		
	    /** --------------------------> CLASS INTERFACE METHODS <--------------------------*/
		
        
	    /** [ METHOD: SET ] */
        public function setPath($str){if($str!==false){$this->globals['dirpath']=globals::pluginPath().'/'.$str.'/';}}
	    public function setFileName($str){$this->globals['filename']=$str.'.html';}
	    public function setTokens($arr){if($arr!==false){$this->globals['tokens']=$arr;}}
        
        /** [ METHOD: REPLACE ] */
        public function replaceTokens($text,$tokens){return($this->tokenReplacement($text,array(0=>$tokens)));}
        
	    /** [ METHOD: GET ] */
	    public function getTemplate(){return($this->getTemplateFunc());}
        public function getError(){return($this->getErrorFunc());}  

        
	    /** --------------------------> CLASS FUNCTIONALITY METHODS <--------------------------*/
		
				
	    /** [ METHOD: CONSTRUCTOR ] */
	    public function __construct()
            {
            /** [ DEFAULT: SETTINGS ] */
            $this->globals['dirpath']=globals::pluginPath().'/templates/';
            $this->globals['filename']=false;
            $this->globals['tokens']=false;
            }
                     
        /** [ METHOD: TOKEN REPLACEMENT ] */     
        private function tokenReplacement($template,$tokens)
            {
            /** [ ERROR: TOKENS NOT SET ] */
            if($tokens===false){return($template);}
            
            /** [ DEFAULT: SETTING ] */
            $xhtml='';
            
            /** [ TOKEN: REPLACEMENT ] */
            foreach($tokens as $token)
                {
                /** [ DEFAULT: STRING TO TEMPLATE ] */
                $str=$template;
                
                /** [ REPLACE: ALL ARRAY TOKENS ] */
                foreach($token as $k => $v){$str=str_ireplace('{'.$k.'}',$v,$str);}
                
                /** [ CONCATENATE: STRING TO XHTML ] */
                $xhtml.=$str;
                }
            
            /** [ RETURN: XHTML ] */
            unset($str); return($xhtml);
            }            
            
        /** [ METHOD: GET TEMPLATE ] */    
        private function getTemplateFunc()
            {
            /** [ ERROR: FILENAME NOT SET ] */
            if($this->globals['filename']==false){debugger::err('filename property not set',__FILE__,__CLASS__,__METHOD__,__LINE__); return(false);}
 
            /** [ ERROR: TEMPLATE FILE NOT FOUND ] */
            if(!file_exists($this->globals['dirpath'].$this->globals['filename'])){return(false);}
            
            /** [ LOAD: TEMPLATE ] */
            ob_start();
            require($this->globals['dirpath'].$this->globals['filename']);
            $template = ob_get_contents();
            ob_end_clean();            
            
            /** [ METHOD: TOKEN REPLACEMENT ] */
            $xhtml=$this->tokenReplacement($template,$this->globals['tokens']);
            
            /** [ RETURN: XHTML ] */
            unset($template); return($xhtml);
            }
	    }
?>