<?php
/**	
 *
 *	VALIDATION CLASS
 *	Author: Paul Hamlington
 *	Purpose: Validate all posted form variables. 
 * 
 */

    /** [ SET NAMESPACE: MODULIZED DOCSAWAY ] */
    namespace modulized_docsaway;
	

    /** [ VALIDATION CLASS ] */
    class validation
        {

		
	    /** --------------------------> CLASS INTERFACE METHODS <--------------------------*/
		
        
	    /** [ METHOD: STATIC ] */
        public static function mandatory($data,$size,$fieldName,$error){return(self::mandatoryFunc(trim($data),$size,$fieldName,$error));}
        public static function email($data,$size,$fieldName,$error){return(self::emailFunc(trim($data),$size,$fieldName,$error));}
        public static function numeric($data,$size,$fieldName,$error){return(self::numericFunc(trim($data),$size,$fieldName,$error));}
        public static function size($data,$size,$fieldName,$error){return(self::maximumSize(trim($data),$size,$fieldName,$error));}
        
        
	    /** --------------------------> CLASS FUNCTIONALITY METHODS <--------------------------*/
		
        
        /** [ METHOD: MANDATORY ] */
        private static function mandatoryFunc($data,$size,$fieldName,$error)
            {
            /** [ ERROR: DATA NOT SET ] */
            if(empty($data))
                {
                /** [ IGNORE: ERROR MESSAGE ] */
                if($error===false){return(false);}
                
                /** [ METHOD: ALERT ] */
                globals::alert(globals::$lang['validation']['t1'].': '.$fieldName.' '.globals::$lang['validation']['m1'],$error,false);
                
                /** [ RETURN: BOOLEAN ] */
                return(false);
                }
            
            /** [ ERROR: MAXIMUM SIZE EXCEEDED ] */
            if(self::maximumSize($data,$size,$fieldName,$error)===false){return(false);}
                        
            /** [ RETURN: BOOLEAN ] */
            return(true);
            }  
            
        /** [ METHOD: EMAIL ] */
        private static function emailFunc($data,$size,$fieldName,$error)
            {
            /** [ REGULAR EXPRESSION ] */
            $pattern='/^[a-z0-9]+([\.a-z0-9_-])*@{1}([a-z0-9]+([a-z0-9_-])*\.{1}[a-z0-9]+([a-z0-9_-])*)+$/i';
            
            /** [ ERROR: NOT A VALID EMAIL ADDRESS ] */
            if(preg_match($pattern,$data)==0)
                {
                /** [ IGNORE: ERROR MESSAGE ] */
                if($error===false){return(false);}
                
                /** [ METHOD: ALERT ] */
                globals::alert(globals::$lang['validation']['t1'].': '.$fieldName.' '.globals::$lang['validation']['m2'],$error,false);
                
                /** [ RETURN: BOOLEAN ] */
                unset($pattern); return(false);
                }
     
            /** [ ERROR: MAXIMUM SIZE EXCEEDED ] */
            if(self::maximumSize($data,$size,$fieldName,$error)===false){unset($pattern); return(false);}
     
            /** [ RETURN: BOOLEAN ] */
            unset($pattern); return(true);
            }
            
        /** [ METHOD: NUMERIC ] */
        private static function numericFunc($data,$size,$fieldName,$error)
            {
            /** [ ERROR: NOT A VALID EMAIL ADDRESS ] */
            if(!is_numeric($data))
                {
                /** [ IGNORE: ERROR MESSAGE ] */
                if($error===false){return(false);}
                
                /** [ METHOD: ALERT ] */
                globals::alert(globals::$lang['validation']['t1'].': '.$fieldName.' '.globals::$lang['validation']['m4'],$error,false); 
                
                /** [ RETURN: BOOLEAN ] */
                return(false);
                }
     
            /** [ ERROR: MAXIMUM SIZE EXCEEDED ] */
            if(self::maximumSize($data,$size,$fieldName,$error)===false){return(false);}
     
            /** [ RETURN: BOOLEAN ] */
            return(true);
            }            
            
        /** [ METHOD: MAXIMUM SIZE ] */    
        private static function maximumSize($data,$size,$fieldName,$error)
            {
            /** [ ERROR: MAXIMUM SIZE EXCEEDED ] */
            if(strlen($data)>$size)
                {
                /** [ IGNORE: ERROR MESSAGE ] */
                if($error===false){return(false);}
                
                /** [ METHOD: ALERT ] */
                globals::alert(globals::$lang['validation']['t1'].': '.$fieldName.' '.globals::$lang['validation']['m3'],$error,false);
                
                /** [ RETURN: BOOLEAN ] */
                return(false);
                }
            
            /** [ RETURN: BOOLEAN ] */
            return(true);
            }
        }
?>