<?php
/**	
 *
 *	ADMIN: CONFIGURATION CLASS
 *	Author: Paul Hamlington
 *	Purpose: Wrap the configurations page building code. 
 * 
 */

/** [ SET NAMESPACE: MODULIZED DOCSAWAY ] */
    namespace modulized_docsaway;
	

/** [ ADMIN: CONFIGURATION CLASS ] */
    final class a__configuration
        {
	    /** [ PRIVATE CLASS PROPERTIES ] */
	    private $globals;
		
		
	    /** --------------------------> CLASS INTERFACE METHODS <--------------------------*/
		
	    /** [ METHOD: SET ] */
        public function setFields($arr){$this->setFieldsFunc($arr);}        
        
	    /** [ METHOD: EXECUTE ] */
	    public function execute(){return($this->executeFunc());}
        
	    /** [ METHOD: GET ] */
	    public function getXHTML(){return($this->getXHTMLFunc());}

        
	    /** --------------------------> CLASS FUNCTIONALITY METHODS <--------------------------*/
		
				
	    /** [ METHOD: CONSTRUCTOR ] */
	    public function __construct()
            {
            /** [ DEFAULT: GLOBALS ] */
            $this->globals = 
                array('postFields'        => false,
                      'email'             => '',
                      'key'               => '',
                      'mode'              => '',
                      'ink'               => '',
                      'paper'             => '',
                      'notificationEmail' => '',
                      'timeFrame'         => '',
                      'product'           => '',
                      'domainName'        => '',
                      'letterContent'     => '',
                      'homeHook'          => '',
                      'clientHook'        => '',
                      'xhtml'             => '');
          
            /** [ RETURN: BOOLEAN ] */
            return(true);
            }
        
        /** [ METHOD: IMPORT CLASS ] */	
        private function importClass($class)
            {
            /** [ CLASS SELECTION ] */
            switch($class)
                {
                /** [ IMPORTED OBJECTS ] */
                case 1: return(new templates());
                case 3: return(new whmcs());
                }
            }	
            
        /** [ METHOD: SET FIELDS ] */    
        private function setFieldsFunc($arr)
            {
            /** [ ERROR: FIELDS NOT SET ] */
            if(empty($arr)){return(false);}
            
            /** [ STORE: POST FIELDS ] */
            $this->globals['license']           =$arr['license'];
            $this->globals['email']             =$arr['email'];
            $this->globals['key']               =$arr['key'];
            $this->globals['mode']              =$arr['mode'];
            $this->globals['ink']               =$arr['ink'];
            $this->globals['paper']             =$arr['paper'];
            $this->globals['notificationEmail'] =$arr['notificationEmail'];
            $this->globals['timeFrame']         =$arr['timeFrame'];
            $this->globals['product']           =array_flip($arr['product']);
            $this->globals['domainName']        =array_flip($arr['domainName']);
            $this->globals['letterContent']     =$arr['letterContent'];
            $this->globals['homeHook']          =$arr['homeHook'];
            $this->globals['clientHook']        =$arr['clientHook'];
            
            /** [ STORE: POST FIELDS ] */
            $this->globals['postFields']=true;

            /** [ RETURN: BOOLEAN ] */
            unset($arr); return(true);
            }       
            
        /** [ METHOD: EXECUTE ] */     
        private function executeFunc()
            {
            /** [ METHOD: CONFIG FILE ] */
            $this->configFile();
            
            /** [ METHOD: BUILD PAGE ] */
            $xhtml=$this->buildPage();
            
            /** [ STORE: XHTML ] */
            $this->globals['xhtml']=$xhtml;
            
            /** [ RETURN: BOOLEAN ] */
            unset($xhtml); return(true);
            }
            
        /** [ METHOD: CONFIG FILE ] */    
        private function configFile()
            {
            /** [ IGNORE: POSTED FIELDS DETECTED ] */
            if($this->globals['postFields']==true){return(true);}
            
            /** [ OBJECT: WHMCS ] */
            $obj=$this->importClass(3);
            $file=$obj->loadSettings('config');
            unset($obj);

            /** [ ERROR: FILE NOT FOUND ] */
            if($file===false){unset($file); return(false);}
            
            /** [ STORE: SETTINGS ] */
            $this->globals['license']           =$file['license'];
            $this->globals['email']             =$file['email'];
            $this->globals['key']               =$file['key'];
            $this->globals['mode']              =$file['mode'];
            $this->globals['ink']               =$file['ink'];
            $this->globals['paper']             =$file['paper'];
            $this->globals['notificationEmail'] =$file['notificationEmail'];
            $this->globals['timeFrame']         =$file['timeFrame'];
            $this->globals['product']           =$file['product'];
            $this->globals['domainName']        =$file['domainName'];
            $this->globals['homeHook']          =$file['homeHook'];
            $this->globals['clientHook']        =$file['clientHook'];
            
            /** [ RETURN: BOOLEAN ] */
            unset($file); return(true);
            }

        /** [ METHOD: MODE MENU ] */    
        private function modeMenu()
            {
            /** [ MENU: OPTIONS ] */
            $tokens[]=array('value:key'=>'TEST','lang:value'=>'Test');
            $tokens[]=array('value:key'=>'LIVE','lang:value'=>'Live');
            
            /** [ MENU: PRE-SELECTED ] */
            foreach($tokens as $k => $v){$tokens[$k]['value:selected']=($v['value:key']==$this->globals['mode'] ? 'selected="selected"' : '');}   
            
            /** [ METHOD: LOAD TEMPLATE ] */
            $xhtml=$this->loadTemplate('form_option',$tokens,false);
            
            /** [ RETURN: XHTML ] */
            unset($tokens); return($xhtml);
            }
            
        /** [ METHOD: HOME HOOK MENU ] */    
        private function homeHookMenu()
            {
            /** [ MENU: OPTIONS ] */
            $tokens[]=array('value:key'=>1,'lang:value'=>'On');
            $tokens[]=array('value:key'=>2,'lang:value'=>'Off');
            
            /** [ MENU: PRE-SELECTED ] */
            foreach($tokens as $k => $v){$tokens[$k]['value:selected']=($v['value:key']==$this->globals['homeHook'] ? 'selected="selected"' : '');}             
            
            /** [ METHOD: LOAD TEMPLATE ] */
            $xhtml=$this->loadTemplate('form_option',$tokens,false);
            
            /** [ RETURN: XHTML ] */
            unset($tokens); return($xhtml);
            } 
            
        /** [ METHOD: CLIENT HOOK MENU ] */    
        private function clientHookMenu()
            {
            /** [ MENU: OPTIONS ] */
            $tokens[]=array('value:key'=>1,'lang:value'=>'On');
            $tokens[]=array('value:key'=>2,'lang:value'=>'Off');
            
            /** [ MENU: PRE-SELECTED ] */
            foreach($tokens as $k => $v){$tokens[$k]['value:selected']=($v['value:key']==$this->globals['clientHook'] ? 'selected="selected"' : '');}             
            
            /** [ METHOD: LOAD TEMPLATE ] */
            $xhtml=$this->loadTemplate('form_option',$tokens,false);
            
            /** [ RETURN: XHTML ] */
            unset($tokens); return($xhtml);
            }              
            
        /** [ METHOD: INK MENU ] */    
        private function inkMenu()
            {
            /** [ MENU: OPTIONS ] */
            $tokens[]=array('value:key'=>'BW','lang:value'=>'Black &amp; White');
            $tokens[]=array('value:key'=>'CL','lang:value'=>'Colour');
            
            /** [ MENU: PRE-SELECTED ] */
            foreach($tokens as $k => $v){$tokens[$k]['value:selected']=($v['value:key']==$this->globals['ink'] ? 'selected="selected"' : '');}             
            
            /** [ METHOD: LOAD TEMPLATE ] */
            $xhtml=$this->loadTemplate('form_option',$tokens,false);
            
            /** [ RETURN: XHTML ] */
            unset($tokens); return($xhtml);
            }
            
        /** [ METHOD: PAPER MENU ] */    
        private function paperMenu()
            {
            /** [ MENU: OPTIONS ] */
            $tokens[]=array('value:key'=>80,'lang:value'=>80);
            
            /** [ MENU: PRE-SELECTED ] */
            foreach($tokens as $k => $v){$tokens[$k]['value:selected']=($v['value:key']==$this->globals['paper'] ? 'selected="selected"' : '');}               
            
            /** [ METHOD: LOAD TEMPLATE ] */
            $xhtml=$this->loadTemplate('form_option',$tokens,false);
            
            /** [ RETURN: XHTML ] */
            unset($tokens); return($xhtml);
            }
            
        /** [ METHOD: TIMEFRAME MENU ] */    
        private function timeFrameMenu()
            {
            /** [ MENU: OPTIONS ] */
            for($i=5; $i<=90; $i++){$tokens[]=array('value:key'=>$i,'lang:value'=>$i.' days');}
            
            /** [ MENU: PRE-SELECTED ] */
            foreach($tokens as $k => $v){$tokens[$k]['value:selected']=($v['value:key']==$this->globals['timeFrame'] ? 'selected="selected"' : '');}               
            
            /** [ METHOD: LOAD TEMPLATE ] */
            $xhtml=$this->loadTemplate('form_option',$tokens,false);
            
            /** [ RETURN: XHTML ] */
            unset($tokens,$i); return($xhtml);
            }            
            
        /** [ METHOD: PRODUCT MENU ] */    
        private function productMenu()
            {
            /** [ OBJECT: WHMCS ] */
            $obj=$this->importClass(3);
            $file=$obj->getProducts();
            unset($obj);
                    
            /** [ ADD: NONE OPTIONS ] */
            $value=($file===false ? 'No Products Available' : 'None');
            $tokens[0]=array('value:key'=>0,'lang:value'=>$value);            
            if(empty($this->globals['product'])){$this->globals['product'][0]=1;}
            
            /** [ BUILD: TOKEN ARRAY ] */
            if($file!==false){foreach($file as $k => $v){$tokens[]=array('value:key'=>$k,'lang:value'=>$v);}}

            /** [ MENU: PRE-SELECTED ] */
            foreach($tokens as $k => $v){$tokens[$k]['value:selected']=(isset($this->globals['product'][$v['value:key']]) ? 'selected="selected"' : '');}                
            
            /** [ METHOD: LOAD TEMPLATE ] */
            $xhtml=$this->loadTemplate('form_option',$tokens,false);
            
            /** [ RETURN: XHTML ] */
            unset($tokens,$file,$value); return($xhtml);
            }
            
        /** [ METHOD: DOMAIN NAME MENU ] */     
        private function domainNameMenu()
            {
            /** [ OBJECT: WHMCS ] */
            $obj=$this->importClass(3);
            $file=$obj->getDomainPricing();
            unset($obj);
            
            /** [ ADD: NONE OPTIONS ] */
            $value=($file===false ? 'No Domain Names Available' : 'None');
            $tokens[0]=array('value:key'=>0,'lang:value'=>'None');
            if(empty($this->globals['domainName'])){$this->globals['domainName'][0]=1;}
            
            /** [ BUILD: TOKEN ARRAY ] */
            if($file!==false){foreach($file as $k => $v){$tokens[]=array('value:key'=>$k,'lang:value'=>$v);}}

            /** [ MENU: PRE-SELECTED ] */
            foreach($tokens as $k => $v){$tokens[$k]['value:selected']=(isset($this->globals['domainName'][$v['value:key']]) ? 'selected="selected"' : '');} 
            
            /** [ METHOD: LOAD TEMPLATE ] */
            $xhtml=$this->loadTemplate('form_option',$tokens,false);
            
            /** [ RETURN: XHTML ] */
            unset($tokens,$file,$value); return($xhtml);
            }
            
        /** [ METHOD: LOAD LETTER CONTENT ] */    
        private function loadLetterContent()
            {
            /** [ LOAD: POST FIELDS LETTER CONTENT ] */
            if($this->globals['postFields']==true){return($this->globals['letterContent']);}
            
            /** [ OBJECT: WHMCS ] */
            $obj=$this->importClass(3);
            $xhtml=$obj->loadSettings('verification_letter');
            unset($obj);
                      
            /** [ METHOD: LOAD TEMPLATE: DEFAULT ] */
            if($xhtml===false){$xhtml=$this->loadTemplate('letter_verification_content',false,false);}
    
            /** [ REPLACE: BREAKS ] */
            $xhtml=str_ireplace("\n",'',$xhtml);
            $xhtml=str_ireplace('<br/>',"\n",$xhtml);
            
            /** [ RETURN: XHTML ] */
            return($xhtml);
            }
            
        /** [ METHOD: BUILD PAGE ] */    
        private function buildPage()
            {
            /** [ LANGUAGE: SETTINGS ] */
            $tokens['lang:configuration_t1']    =globals::$lang['configuration']['t1'];
            $tokens['lang:configuration_t2']    =globals::$lang['configuration']['t2'];
            $tokens['lang:configuration_t3']    =globals::$lang['configuration']['t3'];
            $tokens['lang:configuration_t4']    =globals::$lang['configuration']['t4'];
            $tokens['lang:configuration_t5']    =globals::$lang['configuration']['t5'];
            $tokens['lang:configuration_t6']    =globals::$lang['configuration']['t6'];
            $tokens['lang:configuration_r1']    =globals::$lang['configuration']['r1'];
            $tokens['lang:configuration_r2']    =globals::$lang['configuration']['r2'];
            $tokens['lang:configuration_r4']    =globals::$lang['configuration']['r4'];
            $tokens['lang:configuration_r5']    =globals::$lang['configuration']['r5'];
            $tokens['lang:configuration_r6']    =globals::$lang['configuration']['r6'];
            $tokens['lang:configuration_r7']    =globals::$lang['configuration']['r7'];
            $tokens['lang:configuration_r8']    =globals::$lang['configuration']['r8'];
            $tokens['lang:configuration_r9']    =globals::$lang['configuration']['r9'];
            $tokens['lang:configuration_r10']   =globals::$lang['configuration']['r10'];
            $tokens['lang:configuration_r11']   =globals::$lang['configuration']['r11'];
            $tokens['lang:configuration_r12']   =globals::$lang['configuration']['r12'];
            $tokens['lang:configuration_r13']   =globals::$lang['configuration']['r13'];
            $tokens['lang:configuration_btn']   =globals::$lang['configuration']['btn'];
            
            /** [ VALUE: SETTINGS ] */
            $tokens['value:action']             =globals::$whmcs['modulelink'];
            $tokens['value:license']            =$this->globals['license'];
            $tokens['value:email']              =$this->globals['email'];
            $tokens['value:key']                =$this->globals['key'];
            $tokens['value:home_hook_options']  =$this->homeHookMenu();
            $tokens['value:client_hook_options']=$this->clientHookMenu();
            $tokens['value:mode_options']       =$this->modeMenu();
            $tokens['value:ink_options']        =$this->inkMenu();
            $tokens['value:paper_options']      =$this->paperMenu();
            $tokens['value:notification_email'] =$this->globals['notificationEmail'];
            $tokens['value:timeframe_options']  =$this->timeFrameMenu();
            $tokens['value:product_options']    =$this->productMenu();
            $tokens['value:domainname_options'] =$this->domainNameMenu();
            $tokens['value:letter_content']     =$this->loadLetterContent();
            $tokens['value:btn_value']          =globals::cryption(array('pw'=>md5(globals::FORM_PASSWORD),'action'=>1),'encode');
            
            /** [ METHOD: LOAD TEMPLATE ] */
            $xhtml=$this->loadTemplate('admin_configuration',array(0=>$tokens),false);
            
            /** [ RETURN: XHTML ] */
            unset($tokens); return($xhtml);
            }            
            
        /** [ METHOD: LOAD TEMPLATE ] */
        private function loadTemplate($filename,$tokens,$path)
            {
            /** [ OBJECT: TEMPLATES ] */
            $obj=$this->importClass(1);
            $obj->setPath($path);
            $obj->setFileName($filename);
            $obj->setTokens($tokens);
            $xhtml=$obj->getTemplate();
            
            /** [ RETURN: XHTML ] */
            unset($obj); return($xhtml);
            }
            
        /** [ METHOD: GET XHTML ] */    
        private function getXHTMLFunc()
            {
            /** [ ERROR: XHTML NOT SET ] */
            if(empty($this->globals['xhtml'])){return(false);}
            
            /** [ RETURN: XHTML ] */
            return($this->globals['xhtml']);
            }
	}
?>