<?php
/**	
 *
 *	ADMIN: LETTER CLASS
 *	Author: Paul Hamlington
 *	Purpose: Wrap the letter page building code. 
 * 
 */

    /** [ SET NAMESPACE: MODULIZED DOCSAWAY ] */
    namespace modulized_docsaway;
	

    /** [ ADMIN: LETTER CLASS ] */
    final class a__letter
        {
	    /** [ PRIVATE CLASS PROPERTIES ] */
	    private $globals;
		
		
	    /** --------------------------> CLASS INTERFACE METHODS <--------------------------*/
		
	    /** [ METHOD: SET ] */
        public function setClientID($char){if(validation::size($char,22,false,false)){$this->globals['clientID']=$char;}}
        public function setFields($arr){$this->setFieldsFunc($arr);}         
        
	    /** [ METHOD: EXECUTE ] */
	    public function execute(){return($this->executeFunc());}
        
	    /** [ METHOD: GET ] */
	    public function getXHTML(){return($this->getXHTMLFunc());}

        
	    /** --------------------------> CLASS FUNCTIONALITY METHODS <--------------------------*/
		
				
	    /** [ METHOD: CONSTRUCTOR ] */
	    public function __construct()
            {
            /** [ DEFAULT: GLOBALS ] */
            $this->globals = 
                array('clientID'     => false,
                      'postFields'   => false,
                      'client'       => '----------  ----------',
                      'name'         => '----------  ----------',
                      'companyName'  => '----------  ----------',
                      'emailAddress' => '----------  ----------',
                      'address1'     => '----------  ----------',
                      'address2'     => '----------  ----------',
                      'city'         => '----------  ----------',
                      'state'        => '----------  ----------',
                      'postcode'     => '----------  ----------',
                      'country'      => '----------  ----------',
                      'ink'          => '',
                      'paper'        => '',
                      'mode'         => '',
                      'content'      => '',
                      'xhtml'        => '');

            /** [ RETURN: BOOLEAN ] */
            return(true);
            }
        
        /** [ METHOD: IMPORT CLASS ] */	
        private function importClass($class)
            {
            /** [ CLASS SELECTION ] */
            switch($class)
                {
                /** [ IMPORTED OBJECTS ] */
                case 1: return(new templates());
                case 2: return(new whmcs());
                }
            }
            
        /** [ METHOD: SET FIELDS ] */    
        private function setFieldsFunc($arr)
            {
            /** [ ERROR: FIELDS NOT SET ] */
            if(empty($arr)){return(false);}
            
            /** [ STORE: POST FIELDS ] */
            $this->globals['mode']    =$arr['mode'];
            $this->globals['ink']     =$arr['ink'];
            $this->globals['paper']   =$arr['paper'];
            $this->globals['content'] =$arr['content'];

            /** [ STORE: POST FIELDS ] */
            $this->globals['postFields']=true;

            /** [ RETURN: BOOLEAN ] */
            unset($arr); return(true);
            }             
            
        /** [ METHOD: EXECUTE ] */     
        private function executeFunc()
            {                       
            /** [ METHOD: CONFIG FILE ] */
            $this->configFile();
            
            /** [ METHOD: CLIENT ] */
            $this->client();
            
            /** [ METHOD: BUILD PAGE ] */
            $xhtml=$this->buildPage();
            
            /** [ STORE: XHTML ] */
            $this->globals['xhtml']=$xhtml;
            
            /** [ RETURN: BOOLEAN ] */
            unset($xhtml); return(true);
            }
            
        /** [ METHOD: CONFIG FILE ] */    
        private function configFile()
            {
            /** [ IGNORE: POSTED FIELDS DETECTED ] */
            if($this->globals['postFields']==true){return(true);}
            
            /** [ OBJECT: WHMCS ] */
            $obj=$this->importClass(2);
            $file=$obj->loadSettings('config');
            unset($obj);
            
            /** [ ERROR: FILE NOT FOUND ] */
            if($file===false){unset($file); return(false);}
            
            /** [ STORE: SETTINGS ] */
            $this->globals['mode']  =$file['mode'];
            $this->globals['ink']   =$file['ink'];
            $this->globals['paper'] =$file['paper'];
            
            /** [ RETURN: BOOLEAN ] */
            unset($file); return(true);
            }            
                
        /** [ METHOD: CLIENT ] */    
        private function client()
            {
            /** [ ERROR: CLIENT ID NOT SET ] */
            if(empty($this->globals['clientID'])){return(false);}
            
            /** [ OBJECT: WHMCS ] */
            $obj = $this->importClass(2);            
            $file=$obj->findDetails($this->globals['clientID']);
            unset($obj);
            
            /** [ ERROR: FILE NOT FOUND ] */
            if($file===false){$this->globals['clientID']=false; unset($file); return(false);}
            
            /** [ STORE: CLIENT SETTINGS ] */
            $this->globals['client']       =$file['id'];
            $this->globals['name']         =$file['firstname'].' '.$file['lastname'];
            $this->globals['emailAddress'] =$file['email'];
            $this->globals['address1']     =$file['address1'];
            $this->globals['city']         =$file['city'];
            $this->globals['postcode']     =$file['postcode'];
            $this->globals['country']      =$file['country'];
            
            /** [ OPTIONAL: FIELDS ] */
            if(!empty($file['companyname'])){$this->globals['companyName']=$file['companyname'];}
            if(!empty($file['address2'])){$this->globals['address2']=$file['address2'];}
            if(!empty($file['state'])){$this->globals['state']=$file['state'];}
            
            /** [ RETURN: BOOLEAN ] */
            unset($file); return(true);
            }
            
        /** [ METHOD: MODE MENU ] */    
        private function modeMenu()
            {
            /** [ MENU: OPTIONS ] */
            $tokens[]=array('value:key'=>'TEST','lang:value'=>'Test');
            $tokens[]=array('value:key'=>'LIVE','lang:value'=>'Live');
            
            /** [ MENU: PRE-SELECTED ] */
            foreach($tokens as $k => $v){$tokens[$k]['value:selected']=($v['value:key']==$this->globals['mode'] ? 'selected="selected"' : '');}   
            
            /** [ METHOD: LOAD TEMPLATE ] */
            $xhtml=$this->loadTemplate('form_option',$tokens);
            
            /** [ RETURN: XHTML ] */
            unset($tokens); return($xhtml);
            }
            
        /** [ METHOD: INK MENU ] */    
        private function inkMenu()
            {
            /** [ MENU: OPTIONS ] */
            $tokens[]=array('value:key'=>'BW','lang:value'=>'Black &amp; White');
            $tokens[]=array('value:key'=>'CL','lang:value'=>'Colour');
            
            /** [ MENU: PRE-SELECTED ] */
            foreach($tokens as $k => $v){$tokens[$k]['value:selected']=($v['value:key']==$this->globals['ink'] ? 'selected="selected"' : '');}             
            
            /** [ METHOD: LOAD TEMPLATE ] */
            $xhtml=$this->loadTemplate('form_option',$tokens);
            
            /** [ RETURN: XHTML ] */
            unset($tokens); return($xhtml);
            }
            
        /** [ METHOD: PAPER MENU ] */    
        private function paperMenu()
            {
            /** [ MENU: OPTIONS ] */
            $tokens[]=array('value:key'=>80,'lang:value'=>80);
            
            /** [ MENU: PRE-SELECTED ] */
            foreach($tokens as $k => $v){$tokens[$k]['value:selected']=($v['value:key']==$this->globals['paper'] ? 'selected="selected"' : '');}               
            
            /** [ METHOD: LOAD TEMPLATE ] */
            $xhtml=$this->loadTemplate('form_option',$tokens);
            
            /** [ RETURN: XHTML ] */
            unset($tokens); return($xhtml);
            }
            
        /** [ METHOD: SEARCH TYPE MENU ] */    
        private function searchTypeMenu($type)
            {
            /** [ MENU: OPTIONS ] */
            $tokens[]=array('value:key'=>0,'lang:value'=>'Client ID');
            $tokens[]=array('value:key'=>1,'lang:value'=>'Contact ID');
            
            /** [ MENU: PRE-SELECTED ] */
            foreach($tokens as $k => $v){$tokens[$k]['value:selected']=($v['value:key']==$type ? 'selected="selected"' : '');}               
            
            /** [ METHOD: LOAD TEMPLATE ] */
            $xhtml=$this->loadTemplate('form_option',$tokens);
            
            /** [ RETURN: XHTML ] */
            unset($tokens); return($xhtml);
            }              
            
        /** [ METHOD: LOAD LETTER CONTENT ] */    
        private function loadLetterContent()
            {
            /** [ LOAD: POST FIELDS LETTER CONTENT ] */
            if($this->globals['postFields']==true){return($this->globals['content']);}
            
            /** [ METHOD: LOAD TEMPLATE ] */
            $xhtml=$this->loadTemplate('letter_content',false);
                        
            /** [ REPLACE: BREAKS ] */
            $xhtml=str_ireplace("\n",'',$xhtml);
            $xhtml=str_ireplace('<br/>',"\n",$xhtml);
            
            /** [ RETURN: XHTML ] */
            return($xhtml);
            }
            
        /** [ METHOD: BUILD PAGE ] */    
        private function buildPage()
            {
            /** [ METHOD: CLIENT ID ] */
            $file=globals::clientID($this->globals['clientID'],false,'DECODE');
            
            /** [ LANGUAGE: SETTINGS ] */
            $tokens['lang:letter_t1']     =globals::$lang['letter']['t1'];
            $tokens['lang:letter_t2']     =globals::$lang['letter']['t2'];
            $tokens['lang:letter_t3']     =globals::$lang['letter']['t3'];
            $tokens['lang:letter_t4']     =globals::$lang['letter']['t4'];
            $tokens['lang:letter_b0_1']   =globals::$lang['letter']['b0_1'];
            $tokens['lang:letter_b0_2']   =globals::$lang['letter']['b0_2'];
            $tokens['lang:letter_b1_1']   =globals::$lang['letter']['b1_1'];
            $tokens['lang:letter_b1_2']   =globals::$lang['letter']['b1_2'];
            $tokens['lang:letter_b1_3']   =globals::$lang['letter']['b1_3'];
            $tokens['lang:letter_b1_4']   =globals::$lang['letter']['b1_4'];
            $tokens['lang:letter_b1_5']   =globals::$lang['letter']['b1_5'];
            $tokens['lang:letter_b1_6']   =globals::$lang['letter']['b1_6'];
            $tokens['lang:letter_b1_7']   =globals::$lang['letter']['b1_7'];
            $tokens['lang:letter_b1_8']   =globals::$lang['letter']['b1_8'];
            $tokens['lang:letter_b1_9']   =globals::$lang['letter']['b1_9'];
            $tokens['lang:letter_b1_10']  =globals::$lang['letter']['b1_10'];
            $tokens['lang:letter_b2_1']   =globals::$lang['letter']['b2_1'];
            $tokens['lang:letter_b2_2']   =globals::$lang['letter']['b2_2'];
            $tokens['lang:letter_b2_3']   =globals::$lang['letter']['b2_3'];
            $tokens['lang:letter_b2_3_1'] =globals::$lang['letter']['b2_3_1'];
            $tokens['lang:letter_b2_4']   =globals::$lang['letter']['b2_4'];
            $tokens['lang:letter_b0_btn'] =globals::$lang['letter']['b0_btn'];            
            $tokens['lang:letter_b2_btn'] =globals::$lang['letter']['b2_btn'];            
                        
            /** [ VALUE: SETTINGS ] */
            $tokens['value:action']              =globals::$whmcs['modulelink'];
            $tokens['value:btn1_value']          =globals::cryption(array('pw'=>md5(globals::FORM_PASSWORD),'action'=>2),'encode');            
            $tokens['value:btn2_value']          =globals::cryption(array('pw'=>md5(globals::FORM_PASSWORD),'action'=>2,'clientID'=>$this->globals['clientID'],'mailPDF'=>true),'encode');
            $tokens['value:client_id']           =$file['id'];
            $tokens['value:client']              =($this->globals['clientID']===false ? $this->globals['client'] : '#'.$this->globals['client']);
            $tokens['value:name']                =$this->globals['name'];
            $tokens['value:company_name']        =$this->globals['companyName'];
            $tokens['value:email_address']       =$this->globals['emailAddress'];
            $tokens['value:address1']            =$this->globals['address1'];
            $tokens['value:address2']            =$this->globals['address2'];
            $tokens['value:city']                =$this->globals['city'];
            $tokens['value:state']               =$this->globals['state'];
            $tokens['value:postcode']            =$this->globals['postcode'];
            $tokens['value:country']             =country::conv($this->globals['country']);
            $tokens['value:mode_options']        =$this->modeMenu();
            $tokens['value:ink_options']         =$this->inkMenu();
            $tokens['value:paper_options']       =$this->paperMenu();
            $tokens['value:search_type_options'] =$this->searchTypeMenu($file['type']);
            $tokens['value:letter_content']      =$this->loadLetterContent();
            
            /** [ METHOD: LOAD TEMPLATE ] */
            $xhtml=$this->loadTemplate('admin_letter',array(0=>$tokens));
            
            /** [ RETURN: XHTML ] */
            unset($tokens,$file); return($xhtml);
            }            
            
        /** [ METHOD: LOAD TEMPLATE ] */
        private function loadTemplate($filename,$tokens)
            {
            /** [ OBJECT: TEMPLATES ] */
            $obj=$this->importClass(1);
            $obj->setFileName($filename);
            $obj->setTokens($tokens);
            $xhtml=$obj->getTemplate();
            
            /** [ RETURN: XHTML ] */
            unset($obj); return($xhtml);
            }
            
        /** [ METHOD: GET XHTML ] */    
        private function getXHTMLFunc()
            {
            /** [ ERROR: XHTML NOT SET ] */
            if(empty($this->globals['xhtml'])){return(false);}
            
            /** [ RETURN: XHTML ] */
            return($this->globals['xhtml']);
            }
	    }
?>