<?php
/**	
 *
 *	ADMIN: REPORT CLASS
 *	Author: Paul Hamlington
 *	Purpose: Wrap the report page building code. 
 * 
 */

    /** [ SET NAMESPACE: MODULIZED DOCSAWAY ] */
    namespace modulized_docsaway;	
	

    /** [ ADMIN: REPORT CLASS ] */
    final class a__report
        {
	    /** [ PRIVATE CLASS PROPERTIES ] */
	    private $globals;
		
		
	    /** --------------------------> CLASS INTERFACE METHODS <--------------------------*/
		
	    /** [ METHOD: SET ] */
        public function setStatus($int){if(validation::numeric($int,1,false,false)){$this->globals['status']=$int;}}
        public function setPage($int){if(validation::numeric($int,10,false,false)){$this->globals['page']=$int;}}
       
	    /** [ METHOD: EXECUTE ] */
	    public function execute(){return($this->executeFunc());}
        
	    /** [ METHOD: GET ] */
	    public function getXHTML(){return($this->getXHTMLFunc());}

        
	    /** --------------------------> CLASS FUNCTIONALITY METHODS <--------------------------*/
		
				
	    /** [ METHOD: CONSTRUCTOR ] */
	    public function __construct()
            {
            /** [ DEFAULT: GLOBALS ] */
            $this->globals = 
                array('status' => 0,
                      'page'   => 0,
                      'xhtml'  => '');

            /** [ RETURN: BOOLEAN ] */
            return(true);
            }
        
        /** [ METHOD: IMPORT CLASS ] */	
        private function importClass($class)
            {
            /** [ CLASS SELECTION ] */
            switch($class)
                {
                /** [ IMPORTED OBJECTS ] */
                case 1: return(new templates());
                case 2: return(new whmcs());
                }
            }
               
        /** [ METHOD: EXECUTE ] */     
        private function executeFunc()
            {                  
            /** [ METHOD: BUILD PAGE ] */
            $xhtml=$this->buildPage();
            
            /** [ STORE: XHTML ] */
            $this->globals['xhtml']=$xhtml;
            
            /** [ RETURN: BOOLEAN ] */
            unset($xhtml); return(true);
            }
                      
        /** [ METHOD: BUILD PAGE ] */    
        private function buildPage()
            {
            /** [ LANGUAGE: SETTINGS ] */
            $tokens['lang:report_t1']              =globals::$lang['report']['t1'];
            $tokens['lang:report_t2']              =globals::$lang['report']['t2'];
            $tokens['lang:report_search_status']   =globals::$lang['report']['search_status'];
            $tokens['lang:report_h1']              =globals::$lang['report']['h1'];
            $tokens['lang:report_h2']              =globals::$lang['report']['h2'];
            $tokens['lang:report_h3']              =globals::$lang['report']['h3'];
            $tokens['lang:report_h4']              =globals::$lang['report']['h4'];
            $tokens['lang:report_h5']              =globals::$lang['report']['h5'];
            $tokens['lang:report_h6']              =globals::$lang['report']['h6'];
            $tokens['lang:report_h7']              =globals::$lang['report']['h7'];
            $tokens['lang:report_btn1']            =globals::$lang['report']['btn1'];
            $tokens['lang:report_btn3']            =globals::$lang['report']['btn3'];
            $tokens['lang:report_btn4']            =globals::$lang['report']['btn4'];            
                        
            /** [ VALUE: SETTINGS ] */
            $tokens['value:action']                =globals::$whmcs['modulelink'];
            $tokens['value:btn1']                  =globals::cryption(array('pw'=>md5(globals::FORM_PASSWORD),'action'=>5,'paging'=>0),'encode');   
            $tokens['value:table_rows']            =$this->clientVerificationList();
            $tokens['value:search_status_options'] =$this->statusTypeMenu();
            $tokens['value:search_status']         =$this->globals['status'];

            /** [ METHOD: PAGING ] */
            $paging                                =globals::paging($this->globals['page'],$this->globals['paging']['total']);
            $tokens['value:btn3']                  =globals::cryption(array('pw'=>md5(globals::FORM_PASSWORD),'action'=>5,'paging'=>$paging['p']),'encode');
            $tokens['value:btn4']                  =globals::cryption(array('pw'=>md5(globals::FORM_PASSWORD),'action'=>5,'paging'=>$paging['n']),'encode');            
            $tokens['value:paging_page']           =$paging['page'];
            $tokens['value:paging_total']          =$paging['total'];
            
            /** [ METHOD: LOAD TEMPLATE ] */
            $xhtml=$this->loadTemplate('admin_report',array(0=>$tokens));
            
            /** [ RETURN: XHTML ] */
            unset($tokens,$paging); return($xhtml);
            }     
                        
        /** [ METHOD: STATUS TYPE MENU ] */    
        private function statusTypeMenu()
            {
            /** [ MENU: OPTIONS ] */
            $tokens[]=array('value:key'=>0,'lang:value'=>globals::$lang['report']['search_status_option'][0]);
            $tokens[]=array('value:key'=>1,'lang:value'=>globals::$lang['verification']['status'][1]);
            $tokens[]=array('value:key'=>2,'lang:value'=>globals::$lang['verification']['status'][2]);
            $tokens[]=array('value:key'=>3,'lang:value'=>globals::$lang['verification']['status'][3]);
            
            /** [ MENU: PRE-SELECTED ] */
            foreach($tokens as $k => $v){$tokens[$k]['value:selected']=($v['value:key']==$this->globals['status'] ? 'selected="selected"' : '');}               
            
            /** [ METHOD: LOAD TEMPLATE ] */
            $xhtml=$this->loadTemplate('form_option',$tokens,false);
            
            /** [ RETURN: XHTML ] */
            unset($tokens); return($xhtml);
            }            
            
        /** [ METHOD: CLIENT VERIFICATION LIST ] */    
        private function clientVerificationList()
            {
            /** [ OBJECT: WHMCS ] */
            $obj = $this->importClass(2);            
            $file=$obj->clientVerificationList($this->globals['status'],$this->globals['page']);
            $this->globals['paging']['total']=$file['total'];
            unset($obj);
            
            /** [ ERROR: FILE NOT FOUND ] */
            if($file['resultset']===false){unset($file); $tokens[0]['value:error']=globals::$lang['report']['empty']; return($this->loadTemplate('admin_report_error',$tokens));}
                        
            /** [ STORE: CLIENT SETTINGS ] */
            foreach($file['resultset'] as $k => $v)
                {
                /** [ INCREMENT: NUM ] */
                $num=(!is_numeric($num)) ? 0 : $num+1;
                
                /** [ METHOD: DATE FORMAT ] */
                $arr['c3']=globals::dateFormat('jS F Y',$v['requested_date']);
                $arr['c4']=globals::dateFormat('jS F Y',$v['due_date']);
                $arr['c5']=globals::dateFormat('jS F Y',$v['completed_date']);
                
                /** [ FORMAT: EMPTY DATE ] */
                $arr['c3']=($arr['c3']===false) ? '------' : $arr['c3'];
                $arr['c4']=($arr['c4']===false) ? '------' : $arr['c4'];
                $arr['c5']=($arr['c5']===false) ? '------' : $arr['c5'];
                
                /** [ CREATE: ID ] */
                $arr['id']=globals::clientID($v['client_id'],$v['tbl'],'encode:1');
                
                /** [ CONSTRUCT: TABLE ROWS ] */
                $tokens[]=
                    array('value:c1'      =>$arr['id'],
                          'value:c2'      =>$v['name'],
                          'value:c3'      =>$arr['c3'],
                          'value:c4'      =>$arr['c4'],
                          'value:c5'      =>$arr['c5'],
                          'value:c6'      =>globals::$lang['verification']['status'][$v['status']],
                          'value:btn2_id' =>$num,
                          'value:btn2'    =>globals::cryption(array('pw'=>md5(globals::FORM_PASSWORD),'action'=>5,'clientID'=>$arr['id'],'download'=>true),'encode'),
                          'lang:btn2'     =>globals::$lang['report']['btn2']);              

                /** [ CLEAR: ONLOOP ] */
                unset($arr);
                }     

            /** [ METHOD: LOAD TEMPLATE ] */
            $table=$this->loadTemplate('admin_report_row',$tokens);                    
                
            /** [ RETURN: TABLE ] */
            unset($file,$tokens,$num); return($table);
            }            
            
        /** [ METHOD: LOAD TEMPLATE ] */
        private function loadTemplate($filename,$tokens)
            {
            /** [ OBJECT: TEMPLATES ] */
            $obj=$this->importClass(1);
            $obj->setFileName($filename);
            $obj->setTokens($tokens);
            $xhtml=$obj->getTemplate();
            
            /** [ RETURN: XHTML ] */
            unset($obj); return($xhtml);
            }
            
        /** [ METHOD: GET XHTML ] */    
        private function getXHTMLFunc()
            {
            /** [ ERROR: XHTML NOT SET ] */
            if(empty($this->globals['xhtml'])){return(false);}
            
            /** [ RETURN: XHTML ] */
            return($this->globals['xhtml']);
            }
	    }
?>