<?php
/**	
 *
 *	ADMIN: SIDEBAR CLASS
 *	Author: Paul Hamlington
 *	Purpose: Wrap the sidebar page building code. 
 * 
 */

    /** [ SET NAMESPACE: MODULIZED DOCSAWAY ] */
    namespace modulized_docsaway;	
	

    /** [ ADMIN: SIDEBAR CLASS ] */
    final class a__sidebar
        {
	    /** [ PRIVATE CLASS PROPERTIES ] */
	    private $globals;
		
		
	    /** --------------------------> CLASS INTERFACE METHODS <--------------------------*/
		

	    /** [ METHOD: EXECUTE ] */
	    public function execute(){return($this->executeFunc());}
        
	    /** [ METHOD: GET ] */
	    public function getXHTML(){return($this->getXHTMLFunc());}

        
	    /** --------------------------> CLASS FUNCTIONALITY METHODS <--------------------------*/
		
				
	    /** [ METHOD: CONSTRUCTOR ] */
	    public function __construct()
            {
            /** [ DEFAULT: GLOBALS ] */
            $this->globals = 
                array('accountHolder'    => '----------  ----------',
                      'accountReference' => '----------  ----------',
                      'accountBalance'   => '----------  ----------',
                      'totalSent'        => '----------  ----------',
                      'moduleMode'       => '----------  ----------',
                      'xhtml'            => '');                    
          
            /** [ RETURN: BOOLEAN ] */
            return(true);
            }
        
        /** [ METHOD: IMPORT CLASS ] */	
        private function importClass($class)
            {
            /** [ CLASS SELECTION ] */
            switch($class)
                {
                /** [ IMPORTED OBJECTS ] */
                case 1: return(new templates());
                case 2: return(new docsaway());
                case 3: return(new whmcs());
                }
            }	
            
        /** [ METHOD: EXECUTE ] */     
        private function executeFunc()
            {
            /** [ METHOD: DOCSAWAY ACCOUNT ] */
            $this->docsawayAccount();
            
            /** [ METHOD: BUILD PAGE ] */
            $xhtml=$this->buildPage();
            
            /** [ STORE: XHTML ] */
            $this->globals['xhtml']=$xhtml;
            
            /** [ RETURN: BOOLEAN ] */
            unset($xhtml); return(true);
            }
            
        /** [ METHOD: CONFIG FILE ] */    
        private function configFile()
            {           
            /** [ OBJECT: WHMCS ] */
            $obj=$this->importClass(3);
            $file=$obj->loadSettings('config');
            unset($obj);
            
            /** [ ERROR: FILE NOT FOUND ] */
            if($file===false){unset($file); return(false);}
            
            /** [ STORE: SETTINGS ] */
            $this->globals['moduleMode']=$file['mode']; 
            
            /** [ RETURN: BOOLEAN ] */
            unset($file); return(true);
            }              
            
        /** [ METHOD: DOCSAWAY ACCOUNT ] */    
        private function docsawayAccount()
            {
            /** [ OBJECT: DOCSAWAY ] */
            $obj=$this->importClass(2);
            $file=$obj->account();
            unset($obj);
            
            /** [ ERROR: CONNECTION FAILURE ] */
            if($file===false){unset($file); return(false);}
            
            /** [ METHOD: CONFIG FILE ] */
            $this->configFile();
            
            /** [ STORE: SETTINGS ] */
            $this->globals['accountHolder']=    $file['name'];
            $this->globals['accountReference']= $file['reference'];
            $this->globals['accountBalance']=   globals::BASE_CURRENCY.' '.$file['balance'];
            $this->globals['totalSent']=        $file['volume'].' '.globals::$lang['sidebar']['r4_1'];           

            /** [ RETURN: BOOLEAN ] */
            unset($file); return(true);
            }
  
        /** [ METHOD: BUILD PAGE ] */    
        private function buildPage()
            {
            /** [ LANGUAGE: SETTINGS ] */
            $tokens['lang:sidebar_TITLE']      =globals::PLUGIN_NAME;
            $tokens['lang:sidebar_r1']         =globals::$lang['sidebar']['r1'];
            $tokens['lang:sidebar_r2']         =globals::$lang['sidebar']['r2'];
            $tokens['lang:sidebar_r3']         =globals::$lang['sidebar']['r3'];
            $tokens['lang:sidebar_r4']         =globals::$lang['sidebar']['r4'];
            $tokens['lang:sidebar_r5']         =globals::$lang['sidebar']['r5'];
            $tokens['lang:sidebar_r6']         =globals::$lang['sidebar']['r6'];
            $tokens['lang:sidebar_r7']         =globals::$lang['sidebar']['r7'];
            $tokens['lang:sidebar_r7_1']       =globals::$lang['sidebar']['r7_1'];
            $tokens['lang:sidebar_r8']         =globals::$lang['sidebar']['r8'];
            $tokens['lang:sidebar_r8_1']       =globals::$lang['sidebar']['r8_1'];            
            
            /** [ VALUE: SETTINGS ] */
            $tokens['value:account_holder']    =$this->globals['accountHolder'];
            $tokens['value:account_reference'] =$this->globals['accountReference'];
            $tokens['value:account_balance']   =$this->globals['accountBalance'];
            $tokens['value:total_sent']        =$this->globals['totalSent'];
            $tokens['value:module_mode']       =$this->globals['moduleMode'];
            $tokens['value:path']              =globals::pluginURL();
            $tokens['value:module']            ='Docsaway';    
            $tokens['value:docsaway_guide']    ='http://www.modulized.com/docsaway-userguide/';
            $tokens['value:docsaway_account']  ='https://www.docsaway.com/index_m.php?login=1';
            
            /** [ METHOD: LOAD TEMPLATE ] */
            $xhtml=$this->loadTemplate('admin_sidebar',array(0=>$tokens));
            
            /** [ RETURN: XHTML ] */
            unset($tokens); return($xhtml);
            }            
            
        /** [ METHOD: LOAD TEMPLATE ] */
        private function loadTemplate($filename,$tokens)
            {
            /** [ OBJECT: TEMPLATES ] */
            $obj=$this->importClass(1);
            $obj->setFileName($filename);
            $obj->setTokens($tokens);
            $xhtml=$obj->getTemplate();
            
            /** [ RETURN: XHTML ] */
            unset($obj); return($xhtml);
            }
            
        /** [ METHOD: GET XHTML ] */    
        private function getXHTMLFunc()
            {
            /** [ ERROR: XHTML NOT SET ] */
            if(empty($this->globals['xhtml'])){return(false);}
            
            /** [ RETURN: XHTML ] */
            return($this->globals['xhtml']);
            }
	    }
?>