<?php
/**	
 * 
 *	ADMIN: ACTION CLASS
 *	Author: Paul Hamlington
 *	Purpose: Channel all plugin actions through this class.
 *
 */

    /** [ SET NAMESPACE: MODULIZED DOCSAWAY ] */
    namespace modulized_docsaway;	
	

    /** [ ADMIN: ACTION CLASS ] */
    final class a_action
        {
	/** [ PRIVATE CLASS PROPERTIES ] */	
	private $globals;	
			
                
	/** --------------------------> CLASS INTERFACE METHODS <--------------------------*/
		
	       
	/** [ METHOD: EXECUTE ] */
	public function execute(){$this->executeFunc();}
        
	/** [ METHOD: GET XHTML ] */
    public function getXHTML(){return($this->getXHTMLFunc());}
		
		
	/** --------------------------> CLASS FUNCTIONALITY METHODS <--------------------------*/
		
				
	/** [ METHOD: CONSTRUCTOR ] */		
	public function __construct($post)
            {
            /** [ METHOD: CRYPTION ] */
            $file=globals::cryption(@$post['fmAction'],'decode');

            /** [ POPULATE: GLOBALS ] */
            $this->globals = 
                array('fmAction'    => @$file,
                      'post'        => @$post,
                      'searchP2'    => array('id'=>@$post['search2_id'],'type'=>@$post['search2_type']), 
                      'searchP3'    => array('id'=>@$post['search3_id']),
                      'searchP4'    => array('id'=>@$post['search4_id'],'type'=>@$post['search4_type']),
                      'searchP5'    => array('type'=>@$post['search5_status']),                                    
                      'postFields'  => array(),
                      'xhtml'       => '');
            
            /** [ UNSET: FORM ACTION ] */
            unset($this->globals['post']['fmAction']);
            
            /** [ RETURN: BOOLEAN ] */
            unset($post,$file); return(true);
            }
                    
        /** [ METHOD: IMPORT CLASS ] */	
        private function importClass($class)
            {
            /** [ CLASS SELECTION ] */
            switch($class)
                {
                /** [ IMPORTED OBJECTS ] */
                case  1: return(new a__configuration());
                case  2: return(new a__invoices());    
                case  3: return(new a__verification());
                case  4: return(new a__report());
                case  5: return(new a__letter());
                case  6: return(new a_action_configuration());    
                case  7: return(new a_action_invoices());    
                case  8: return(new a_action_verification());
                case  9: return(new a_action_letter());
                case 11: return(new templates());
                case 12: return(new pdf_certificate());
                }
            }
               
        /** [ METHOD: EXECUTE ] */		
	private function executeFunc()
            {    
            /** [ METHOD: PAGE ACCESS ] */
            switch($this->globals['fmAction']['action'])
                {
                /** [ ACTION: CONFIGURATION ] */
                case 1: $this->actionConfiguration(); break; 
                
                /** [ ACTION: LETTER ] */
                case 2: $this->actionLetter(); break;            
            
                /** [ ACTION: INVOICES ] */
                case 3: $this->actionInvoice(); break; 
                
                /** [ ACTION: VERIFICATION ] */
                case 4: $this->actionVerification(); break; 
                
                /** [ ACTION: REPORT ] */
                case 5: $this->actionReport(); break;  
                }
                
             /** [ DEFAULT: BUILD PLUGIN ] */
            $this->buildPlugin();    
                
            /** [ RETURN: BOOLEAN ] */
            return(true);
            }
            
        /** [ METHOD: ACTION CONFIGURATION ] */    
        private function actionConfiguration()
            {
            /** [ PROPERTY: PAGE ] */
            $this->globals['fmAction']['page']=1;
                    
            /** [ POST: TO ARRAY ] */
            $arr=$this->globals['post'];
                    
            /** [ STORE: POSTFIELDS ] */
            $this->globals['postFields'][1]=
                array('license'           => @$arr['license'],
                      'email'             => @$arr['email'],
                      'key'               => @$arr['key'],
                      'mode'              => @$arr['mode'],
                      'ink'               => @$arr['ink'],                    
                      'paper'             => @$arr['paper'],
                      'notificationEmail' => @$arr['notification_email'],
                      'timeFrame'         => @$arr['time_frame'],
                      'product'           => @$arr['product'],
                      'domainName'        => @$arr['domain_name'],
                      'letterContent'     => @$arr['letter_content'],
                      'homeHook'          => @$arr['home_hook'],
                      'clientHook'        => @$arr['client_hook']);

            /** [ OBJECT: ACTION: CONFIGURATION ] */
            $obj=$this->importClass(6);
            $obj->setPassword($this->globals['fmAction']['pw']);
            $obj->setFields($this->globals['postFields'][1]);                    
            $obj->execute();

            /** [ RETURN: BOOLEAN ] */
            unset($obj,$arr); return(true);
            }
            
        /** [ METHOD: ACTION LETTER ] */    
        private function actionLetter()
            {
            /** [ PROPERTY: PAGE ] */
            $this->globals['fmAction']['page']=2;

            /** [ IGNORE: ACTION INVOICES ] */
            if($this->globals['fmAction']['mailPDF']!==true){return(true);}
            
            /** [ POST: TO ARRAY ] */
            $arr=$this->globals['post'];            
            
            /** [ STORE: POSTFIELDS ] */
            $this->globals['postFields'][2] = 
                array('mode'    => @$arr['mode'],
                      'ink'     => @$arr['ink'],                    
                      'paper'   => @$arr['paper'],
                      'content' => @$arr['letter_content']);  
            
            /** [ OBJECT: ACTION: LETTER ] */
            $obj=$this->importClass(9);
            $obj->setPassword($this->globals['fmAction']['pw']);
            $obj->setClientID($this->globals['fmAction']['clientID']);
            $obj->setFields($this->globals['postFields'][2]);
            $obj->execute();
            
            /** [ RETURN: BOOLEAN ] */
            unset($obj,$arr); return(true); 
            }              
            
        /** [ METHOD: ACTION INVOICE ] */    
        private function actionInvoice()
            {
            /** [ PROPERTY: PAGE ] */
            $this->globals['fmAction']['page']=3;

            /** [ IGNORE: ACTION INVOICES ] */
            if($this->globals['fmAction']['mailPDF']!==true){return(true);}
            
            /** [ POST: TO ARRAY ] */
            $arr=$this->globals['post'];            
            
            /** [ STORE: POSTFIELDS ] */
            $this->globals['postFields'][3] = 
                array('mode'  => @$arr['mode'],
                      'ink'   => @$arr['ink'],                    
                      'paper' => @$arr['paper']);  
            
            /** [ OBJECT: ACTION: INVOICES ] */
            $obj=$this->importClass(7);
            $obj->setPassword($this->globals['fmAction']['pw']);
            $obj->setInvoiceID($this->globals['fmAction']['invoiceID']);
            $obj->setClientID($this->globals['fmAction']['clientID']);
            $obj->setFields($this->globals['postFields'][3]);
            $obj->execute();
            
            /** [ RETURN: BOOLEAN ] */
            unset($obj,$arr); return(true); 
            }
            
        /** [ METHOD: ACTION VERIFICATION ] */    
        private function actionVerification()
            {
            /** [ PROPERTY: PAGE ] */
            $this->globals['fmAction']['page']=4;

            /** [ IGNORE: ACTION INVOICES ] */
            if($this->globals['fmAction']['mailPDF']!==true){return(true);}
            
            /** [ POST: TO ARRAY ] */
            $arr=$this->globals['post'];            
            
            /** [ STORE: POSTFIELDS ] */
            $this->globals['postFields'][4] = 
                array('mode'  => @$arr['mode'],
                      'ink'   => @$arr['ink'],                    
                      'paper' => @$arr['paper']);  
            
            /** [ OBJECT: ACTION: VERIFICATION ] */
            $obj=$this->importClass(8);
            $obj->setPassword($this->globals['fmAction']['pw']);
            $obj->setClientID($this->globals['fmAction']['clientID']);
            $obj->setFields($this->globals['postFields'][4]);
            $obj->execute();
            
            /** [ RETURN: BOOLEAN ] */
            unset($obj,$arr); return(true); 
            }            
             
        /** [ METHOD: ACTION REPORT ] */    
        private function actionReport()
            {
            /** [ PROPERTY: PAGE ] */
            $this->globals['fmAction']['page']=5;

            /** [ IGNORE: ACTION DOWNLOAD ] */
            if($this->globals['fmAction']['download']!==true){return(true);}
            
            /** [ OBJECT: PDF CERTIFICATE ] */
            $obj=$this->importClass(12);
            $obj->setClientID($this->globals['fmAction']['clientID']);
            $obj->execute();
            $obj->getPDFDownload();
            
            /** [ RETURN: BOOLEAN ] */
            unset($obj); return(true); 
            }             
            
        /** [ METHOD: BUILD PLUGIN ] */    
        private function buildPlugin()
            {
            /** [ DEFAULT: STARTING PAGE ] */
            if(empty($this->globals['fmAction']['page'])){$this->globals['fmAction']['page']=1;}
            
            /** [ LOAD: PAGE ] */
            switch($this->globals['fmAction']['page'])
                {
                /** [ OBJECT: CONFIGURATION ] */
                case 1:
                    $obj=$this->importClass(1);
                    $obj->setFields(@$this->globals['postFields'][1]);
                    $obj->execute();
                    $arr['xhtml']=$obj->getXHTML();
                    unset($obj); break;
                
                /** [ OBJECT: LETTER ] */
                case 2:
                    $obj=$this->importClass(5);
                    $obj->setClientID(@globals::clientID($this->globals['searchP2']['id'],@$this->globals['searchP2']['type'],'ENCODE:1'));
                    $obj->setFields(@$this->globals['postFields'][2]);            
                    $obj->execute();
                    $arr['xhtml']=$obj->getXHTML();
                    unset($obj); break;
                
                /** [ OBJECT: INVOICES ] */
                case 3:
                    $obj=$this->importClass(2);
                    $obj->setInvoiceID(@$this->globals['searchP3']['id']);
                    $obj->setFields(@$this->globals['postFields'][3]);            
                    $obj->execute();
                    $arr['xhtml']=$obj->getXHTML();
                    unset($obj); break;
            
                /** [ OBJECT: VERIFICATION ] */
                case 4:
                    $obj=$this->importClass(3);
                    $obj->setClientID(@globals::clientID($this->globals['searchP4']['id'],@$this->globals['searchP4']['type'],'ENCODE:1'));
                    $obj->setFields(@$this->globals['postFields'][4]);            
                    $obj->execute();
                    $arr['xhtml']=$obj->getXHTML();
                    unset($obj); break;          
            
                /** [ OBJECT: REPORT ] */
                case 5:
                    $obj=$this->importClass(4);
                    $obj->setStatus(@$this->globals['searchP5']['type']);
                    $obj->setPage(@$this->globals['fmAction']['paging']);
                    $obj->execute();
                    $arr['xhtml']=$obj->getXHTML();
                    unset($obj); break;
                }
            
            /** [ LANGUAGE: SETTINGS ] */
            $tokens['lang:nav1']       =globals::$lang['nav'][1];
            $tokens['lang:nav2']       =globals::$lang['nav'][2];
            $tokens['lang:nav3']       =globals::$lang['nav'][3];
            $tokens['lang:nav4']       =globals::$lang['nav'][4];
            $tokens['lang:nav5']       =globals::$lang['nav'][5];
            $tokens['lang:page_title'] =globals::$lang['nav'][$this->globals['fmAction']['page']];
            
            /** [ VALUE: SETTINGS ] */
            $tokens['value:action']      =globals::$whmcs['modulelink'];
            $tokens['value:nav1']        =globals::cryption(array('page'=>1),'encode');
            $tokens['value:nav2']        =globals::cryption(array('page'=>2),'encode');
            $tokens['value:nav3']        =globals::cryption(array('page'=>3),'encode');
            $tokens['value:nav4']        =globals::cryption(array('page'=>4),'encode');
            $tokens['value:nav5']        =globals::cryption(array('page'=>5),'encode');
            $tokens['value:alert']       =(!empty(globals::$alert['message']) ? globals::$alert['message'] : '');
            $tokens['value:alert_class'] =(!empty(globals::$alert['type']) ? globals::$alert['type'] : '');
            $tokens['value:body']        =$arr['xhtml'];
            $tokens['value:path']        =globals::pluginURL();            
            unset($arr);

            /** [ OBJECT: TEMPLATES ] */
            $obj=$this->importClass(11);
            $obj->setFileName('admin_structure');
            $obj->setTokens(array(0=>$tokens));
            $this->globals['xhtml']=$obj->getTemplate();
            unset($obj);
            
            /** [ RETURN: BOOLEAN ] */
            unset($tokens); return(true);
            }   
              
        /** [ METHOD: GET XHTML ] */    
        private function getXHTMLFunc()
            {
            /** [ ERROR: XHTML NOT SET ] */
            if(empty($this->globals["xhtml"])){return('');}
            
            /** [ RETURN: XHTML ] */
            return($this->globals["xhtml"]);
            }             
        }
?>