<?php
/**	
 * 
 *	CLIENT: ACTION CLASS
 *	Author: Paul Hamlington
 *	Purpose: Channel all plugin actions through this class.
 *
 */

    /** [ SET NAMESPACE: MODULIZED DOCSAWAY ] */
    namespace modulized_docsaway;	
	

    /** [ CLIENT: ACTION CLASS ] */
    final class c_action
        {
	    /** [ PRIVATE CLASS PROPERTIES ] */
	    private $globals;
			
                
	    /** --------------------------> CLASS INTERFACE METHODS <--------------------------*/
		
	       
	    /** [ METHOD: EXECUTE ] */
	    public function execute(){$this->executeFunc();}
        
        /** [ METHOD: GET STRUCTURE ] */
        public function getStructure(){return($this->getStructureFunc());}
		
		
	    /** --------------------------> CLASS FUNCTIONALITY METHODS <--------------------------*/
		
				
	    /** [ METHOD: CONSTRUCTOR ] */
	    public function __construct($post)
            {
            /** [ METHOD: CRYPTION ] */
            $file=globals::cryption(@$post['fmAction'],'decode');
            
            /** [ POPULATE: GLOBALS ] */
            $this->globals = 
                array('fmAction'   => @$file,
                      'post'       => @$post, 
                      'postFields' => array(),
                      'structure'  => $this->clientAreaSettings());
            
            /** [ UNSET: FORM ACTION ] */
            unset($this->globals['post']['fmAction']);
                        
            /** [ RETURN: BOOLEAN ] */
            unset($post,$file); return(true);
            }
                    
        /** [ METHOD: IMPORT CLASS ] */	
        private function importClass($class)
            {
            /** [ CLASS SELECTION ] */
            switch($class)
                {
                /** [ IMPORTED OBJECTS ] */
                case  1: return(new c__verification());
                case  2: return(new c_action_verification());
                }
            }
                
        /** [ METHOD: EXECUTE ] */		
	    private function executeFunc()
            {    
            /** [ ERROR: LOGIN NOT FOUND ] */
            if(!is_numeric(globals::$whmcs['uid'])){return(false);}
            
            /** [ METHOD: PAGE ACCESS ] */
            switch($this->globals['fmAction']['action'])
                {
                /** [ ACTION: VERIFICATION ] */
                case 1: $this->actionVerification(); break;             
                }
                
             /** [ DEFAULT: BUILD PLUGIN ] */
            $this->buildPlugin();    
                
            /** [ RETURN: BOOLEAN ] */
            return(true);
            }
            
        /** [ METHOD: ACTION CONFIGURATION ] */    
        private function actionVerification()
            {   
            /** [ POST: TO ARRAY ] */
            $arr=$this->globals['post'];
                    
            /** [ STORE: POSTFIELDS ] */
            $this->globals['postFields'][1]=array('clientID'=>@$arr['id'],'code'=>@$arr['code']);                     
                                
            /** [ OBJECT: ACTION: VERIFICATION ] */
            $obj =$this->importClass(2);
            $obj->setPassword($this->globals['fmAction']['pw']);
            $obj->setFields($this->globals['postFields'][1]);                    
            $obj->execute();

            /** [ RETURN: BOOLEAN ] */
            unset($obj,$arr); return(true);
            }
   
        /** [ METHOD: BUILD PLUGIN ] */    
        private function buildPlugin()
            {            
            /** [ OBJECT: VERIFICATION ] */
            $obj=$this->importClass(1);
            $obj->setFields(@$this->globals['postFields'][1]);            
            $obj->execute();
            $arr['verifications']=$obj->getXHTML();
            unset($obj);             
            
            /** [ LANGUAGE: SETTINGS ] */
            $tokens['langNav1']  =globals::$lang['nav'][5];
            $tokens['langTitle'] =globals::$lang['verification']['c_title'];
            
            /** [ VALUE: SETTINGS ] */
            $tokens['valueAlert']        =(!empty(globals::$alert['message']) ? globals::$alert['message'] : '');
            $tokens['valueAlertClass']   =(!empty(globals::$alert['type']) ? globals::$alert['type'] : '');
            $tokens['valueVerification'] =$arr['verifications'];
            unset($arr);
            
            /** [ STORE: STRUCTURE ] */
            $this->globals['structure']['vars']=$tokens;
            
            /** [ RETURN: BOOLEAN ] */
            unset($tokens); return(true);
            }
            
        /** [ METHOD: CLIENT AREA SETTINGS ] */     
        private function clientAreaSettings()
            {
            /** [ BUILD: CLIENT AREA STRUCTURE ] */
            $arr['pagetitle']    =globals::$lang['verification']['c_title'];
            $arr['breadcrumb']   =array('index.php?m='.globals::PLUGIN_ID=>globals::$lang['verification']['c_title']);
            $arr['templatefile'] ='templates/client_structure';
            $arr['requirelogin'] =true;
            
            /** [ RETURN: ARRAY ] */
            return($arr);
            }
                        
        /** [ METHOD: GET STRUCTURE ] */    
        private function getStructureFunc()
            {
            /** [ ERROR: STRUCTURE NOT SET ] */
            if(empty($this->globals['structure'])){return('');}
            
            /** [ RETURN: STRUCTURE ] */
            return($this->globals['structure']);
            }             
        }
?>