<?php
/**	
 *
 *	HOOK: CLIENT SUMMARY CLASS
 *	Author: Paul Hamlington
 *	Purpose: Wrap the client summary hook code.
 * 
 */

    /** [ SET NAMESPACE: MODULIZED DOCSAWAY ] */
    namespace modulized_docsaway;	
	

    /** [ HOOK: CLIENT SUMMARY CLASS ] */
    final class h_client_summary
        {
	    /** [ PRIVATE CLASS PROPERTIES ] */
	    private $globals;
		
		
	    /** --------------------------> CLASS INTERFACE METHODS <--------------------------*/
		

        /** [ METHOD: SET ] */
        public function setClientID($int){$this->globals['clientID']='CL'.$int;}
        
	    /** [ METHOD: EXECUTE ] */
	    public function execute(){return($this->executeFunc());}
        
	    /** [ METHOD: GET ] */
	    public function getXHTML(){return($this->getXHTMLFunc());}

        
	    /** --------------------------> CLASS FUNCTIONALITY METHODS <--------------------------*/
		
				
	    /** [ METHOD: CONSTRUCTOR ] */
	    public function __construct()
            {
            /** [ DEFAULT: GLOBALS ] */
            $this->globals = 
                array('clientID'      => '------',
                      'name'          => '------',
                      'companyName'   => '------',
                      'emailAddress'  => '------',
                      'address1'      => '------',
                      'address2'      => '------',
                      'city'          => '------',
                      'state'         => '------',
                      'postcode'      => '------',
                      'country'       => '------',
                      'status'        => 0,
                      'code'          => '------',   
                      'reference'     => '------',
                      'requestedDate' => '------',
                      'completedDate' => '------',
                      'clientHook'    => '',
                      'xhtml'         => '');                    
          
            /** [ RETURN: BOOLEAN ] */
            return(true);
            }
        
        /** [ METHOD: IMPORT CLASS ] */	
        private function importClass($class)
            {
            /** [ CLASS SELECTION ] */
            switch($class)
                {
                /** [ IMPORTED OBJECTS ] */
                case 1: return(new templates());
                case 2: return(new whmcs());                    
                }
            }	
            
        /** [ METHOD: EXECUTE ] */     
        private function executeFunc()
            {         
            /** [ METHOD: CONFIG FILE ] */
            $this->configFile();
            
            /** [ METHOD: CLIENT VERIFICATION ] */
            $this->clientVerification();  
            
            /** [ METHOD: CLIENT ] */
            $this->client();
            
            /** [ METHOD: BUILD PAGE ] */
            if(($xhtml=$this->buildPage())===false){return(false);}
            
            /** [ STORE: XHTML ] */
            $this->globals['xhtml']=$xhtml;
            
            /** [ RETURN: BOOLEAN ] */
            unset($xhtml); return(true);
            }
            
        /** [ METHOD: CONFIG FILE ] */    
        private function configFile()
            {           
            /** [ OBJECT: WHMCS ] */
            $obj=$this->importClass(2);
            $file=$obj->loadSettings('config');
            unset($obj);
            
            /** [ ERROR: FILE NOT FOUND ] */
            if($file===false){unset($file); return(false);}
            
            /** [ STORE: SETTINGS ] */
            $this->globals['clientHook']=$file['clientHook']; 
            
            /** [ RETURN: BOOLEAN ] */
            unset($file); return(true);
            }               
            
        /** [ METHOD: CLIENT VERIFICATION ] */    
        private function clientVerification()
            {
            /** [ ERROR: CLIENT ID NOT SET ] */
            if(empty($this->globals['clientID'])){return(false);}
            
            /** [ OBJECT: WHMCS ] */
            $obj=$this->importClass(2);
            $file=$obj->clientVerification($this->globals['clientID']);
            unset($obj);
            
            /** [ ERROR: FILE NOT FOUND ] */
            if($file===false){unset($file); return(false);}
            
            /** [ STORE: ADDRESS VERIFICATION SETTINGS ] */
            $this->globals['status']    =$file['status'];
            $this->globals['code']      =$file['code'];
            $this->globals['reference'] =$file['reference'];

            /** [ OPTIONAL: FIELDS ] */
            if($file['requested_date']!=0){$this->globals['requestedDate']=globals::dateFormat('jS F Y',$file['requested_date']);}
            if($file['completed_date']!=0){$this->globals['completedDate']=globals::dateFormat('jS F Y',$file['completed_date']);}

            /** [ RETURN: BOOLEAN ] */
            unset($file); return(true);
            }  
            
        /** [ METHOD: CLIENT ] */    
        private function client()
            {
            /** [ ERROR: CLIENT ID NOT SET ] */
            if(empty($this->globals['clientID'])){return(false);}
            
            /** [ OBJECT: WHMCS ] */
            $obj = $this->importClass(2);            
            $file=$obj->findDetails($this->globals['clientID']);
            unset($obj);
            
            /** [ ERROR: FILE NOT FOUND ] */
            if($file===false){$this->globals['clientID']=false; unset($file); return(false);}
            
            /** [ STORE: CLIENT SETTINGS ] */
            $this->globals['name']         =$file['firstname'].' '.$file['lastname'];
            $this->globals['emailAddress'] =$file['email'];
            $this->globals['address1']     =$file['address1'];
            $this->globals['city']         =$file['city'];
            $this->globals['postcode']     =$file['postcode'];
            $this->globals['country']      =$file['country'];
            
            /** [ OPTIONAL: FIELDS ] */
            if(!empty($file['companyname'])){$this->globals['companyName']=$file['companyname'];}
            if(!empty($file['address2'])){$this->globals['address2']=$file['address2'];}
            if(!empty($file['state'])){$this->globals['state']=$file['state'];}
            
            /** [ RETURN: BOOLEAN ] */
            unset($file); return(true);
            }            
            
        /** [ METHOD: BUILD PAGE ] */    
        private function buildPage()
            {
            /** [ HOOK: CLIENT DISABLED ] */
            if($this->globals['clientHook']==2){return(false);}
            
            /** [ LANGUAGE: SETTINGS ] */
            $tokens['lang:client_summary_t1']  =globals::PLUGIN_NAME.' '.globals::$lang['client_summary']['t1'];
            $tokens['lang:client_summary_r1']  =globals::$lang['client_summary']['r1'];
            $tokens['lang:client_summary_r2']  =globals::$lang['client_summary']['r2'];
            $tokens['lang:client_summary_r3']  =globals::$lang['client_summary']['r3'];
            $tokens['lang:client_summary_r4']  =globals::$lang['client_summary']['r4'];
            $tokens['lang:client_summary_r5']  =globals::$lang['client_summary']['r5'];
            $tokens['lang:client_summary_r6']  =globals::$lang['client_summary']['r6'];
            $tokens['lang:client_summary_r7']  =globals::$lang['client_summary']['r7'];
            $tokens['lang:client_summary_r8']  =globals::$lang['client_summary']['r8'];
            $tokens['lang:client_summary_r9']  =globals::$lang['client_summary']['r9'];
            $tokens['lang:client_summary_r10'] =globals::$lang['client_summary']['r10'];
            $tokens['lang:client_summary_r11'] =globals::$lang['client_summary']['r11'];
            $tokens['lang:client_summary_r12'] =globals::$lang['client_summary']['r12'];
            $tokens['lang:client_summary_r13'] =globals::$lang['client_summary']['r13'];
            $tokens['lang:client_summary_r14'] =globals::$lang['client_summary']['r14'];

            /** [ VALUE: SETTINGS ] */
            $tokens['value:status']            =globals::$lang['verification']['status'][$this->globals['status']];
            $tokens['value:name']              =$this->globals['name'];
            $tokens['value:company_name']      =$this->globals['companyName'];
            $tokens['value:email']             =$this->globals['emailAddress'];
            $tokens['value:address1']          =$this->globals['address1'];
            $tokens['value:address2']          =$this->globals['address2'];
            $tokens['value:city']              =$this->globals['city'];
            $tokens['value:state']             =$this->globals['state'];
            $tokens['value:postcode']          =$this->globals['postcode'];
            $tokens['value:country']           =country::conv($this->globals['country']);
            $tokens['value:reference']         =$this->globals['reference'];
            $tokens['value:requested_date']    =$this->globals['requestedDate'];
            $tokens['value:completed_date']    =$this->globals['completedDate'];
            $tokens['value:code']              =$this->globals['code'];
            
            /** [ METHOD: LOAD TEMPLATE ] */
            $xhtml=$this->loadTemplate('admin_client_summary',array(0=>$tokens));
            
            /** [ RETURN: XHTML ] */
            unset($tokens); return($xhtml);
            }            
            
        /** [ METHOD: LOAD TEMPLATE ] */
        private function loadTemplate($filename,$tokens)
            {
            /** [ OBJECT: TEMPLATES ] */
            $obj=$this->importClass(1);
            $obj->setFileName($filename);
            $obj->setTokens($tokens);
            $xhtml=$obj->getTemplate();
            
            /** [ RETURN: XHTML ] */
            unset($obj); return($xhtml);
            }
            
        /** [ METHOD: GET XHTML ] */    
        private function getXHTMLFunc()
            {
            /** [ ERROR: XHTML NOT SET ] */
            if(empty($this->globals['xhtml'])){return(false);}
            
            /** [ RETURN: XHTML ] */
            return($this->globals['xhtml']);
            }
	}
?>