<?php
/**	
 * 
 *	HOOK: DAILY CRONJOB CLASS
 *	Author: Paul Hamlington
 *	Purpose: Wrap the daily cronjob hook code.
 *
 */

    /** [ SET NAMESPACE: MODULIZED DOCSAWAY ] */
    namespace modulized_docsaway;	
	

    /** [ HOOK: DAILY CRONJOB CLASS ] */
    final class h_daily_cronjob
        {
	    /** [ PRIVATE CLASS PROPERTIES ] */
	    private $globals;
			
                
	    /** --------------------------> CLASS INTERFACE METHODS <--------------------------*/
		
	
	    /** [ METHOD: EXECUTE ] */
	    public function execute(){$this->executeFunc();}
		
		
	    /** --------------------------> CLASS FUNCTIONALITY METHODS <--------------------------*/
		
				
	    /** [ METHOD: CONSTRUCTOR ] */
	    public function __construct()
            {
            /** [ DEFAULT: GLOBALS ] */
            $this->globals = array('to'=>'','from'=>'');
            
            /** [ RETURN: BOOLEAN ] */
            return(true);            
            }
                    
        /** [ METHOD: IMPORT CLASS ] */	
        private function importClass($class)
            {
            /** [ CLASS SELECTION ] */
            switch($class)
                {
                /** [ IMPORTED OBJECTS ] */
                case 1: return(new whmcs());
                case 2: return(new templates());
                }
            }	
       
        /** [ METHOD: EXECUTE ] */		
	    private function executeFunc()
            {     
            /** [ METHOD: CONFIG FILE ] */
            if($this->configFile()===false){return(false);}
            
            /** [ METHOD: WHMCS CONFIGURATION ] */
            $this->WHMCSConfiguration();           
            
            /** [ METHOD: CLIENT VERIFICATION OVERDUE ] */
            if(($file=$this->clientVerificationOverDue())==false){unset($file); return(false);}

            /** [ METHOD: EMAIL ] */
            $this->email($file);
            
            /** [ RETURN: BOOLEAN ] */
            return(true);
            }
            
        /** [ METHOD: CONFIG FILE ] */    
        private function configFile()
            {
            /** [ OBJECT: WHMCS ] */
            $obj=$this->importClass(1);
            $file=$obj->loadSettings('config');
            unset($obj);
            
            /** [ ERROR: FILE NOT FOUND ] */
            if($file===false){debugger::err('Config file not found',__FILE__,__CLASS__,__METHOD__,__LINE__); unset($file); return(false);}
            
            /** [ STORE: EMAIL ] */
            $this->globals['to']=$file['email'];

            /** [ RETURN: BOOLEAN ] */
            unset($file); return(true);
            }

        /** [ METHOD: WHMCS CONFIGURATION ] */    
        private function WHMCSConfiguration()
            {
            /** [ OBJECT: WHMCS ] */
            $obj=$this->importClass(1);
            $file=$obj->getConfiguration();
            unset($obj);            

            /** [ STORE: EMAIL ] */
            $this->globals['from']=$file['email'];            
    
            /** [ RETURN: BOOLEAN ] */
            unset($file); return(true);
            }              
            
        /** [ METHOD: CONFIGURATION FILE ] */    
        private function clientVerificationOverDue()
            {
            /** [ OBJECT: WHMCS ] */
            $obj=$this->importClass(1);
            $file=$obj->clientVerificationOverDue(date('Y-m-d'));
            unset($obj);            
            
            /** [ ERROR: RESULTSET EMPTY ] */
            if($file===false){globals::logActivity(globals::$lang['log']['cronjob']['m1'],array('count'=>0)); unset($file); return(false);}
                       
            /** [ RETURN: FILE ] */
            return($file);
            }         
            
        /** [ METHOD: EMAIL ] */
        private function email($file)
            {
            /** [ DEFAULT: TOKENS ] */
            $tokens='';
            
            /** [ LOOP: CLIENT LIST ] */
            foreach($file as $k => $v)
                {
                /** [ LANGUAGE: TOKEN SELECTION ] */
                $lang['id']=(($v['tbl']==0) ? globals::$lang['email']['clientID'] : globals::$lang['email']['contactID']);
                
                /** [ BUILD: CLIENT LIST ] */
                $tokens['value:client_list'].=
                    $lang['id'].': '.$v['client_id']."\n".
                    globals::$lang['email']['name'].': '.$v['name']."\n".
                    globals::$lang['email']['requestedDate'].': '.globals::dateFormat('jS F Y',$v['requested_date'])."\n".
                    globals::$lang['email']['dueDate'].': '.globals::dateFormat('jS F Y',$v['due_date'])."\n\n";
                
                /** [ CLEAR: ONLOOP ] */
                unset($lang);
                }
                
            /** [ METHOD: LOAD TEMPLATE ] */
            $message=$this->loadTemplate('email_verification_overdue',array(0=>$tokens));    
               
            /** [ METHOD: EMAIL ] */
            $sent=globals::email($this->globals['to'],$this->globals['from'],globals::EMAIL_FROM_NAME,globals::$lang['email']['overdue']['subject'],$message);
            
            /** [ ERROR: EMAIL FAILED TO SEND ] */
            if($sent===false)
                {
                /** [ METHOD: DEBUGGER ] */
                debugger::err('Email verification overdue sending failure',__FILE__,__CLASS__,__METHOD__,__LINE__); 
                
                /** [ METHOD: LOG ACTIVITY ] */
                globals::logActivity(globals::$lang['log']['email']['m1'],false);                
                
                /** [ RETURN: BOOLEAN ] */
                unset($file,$tokens,$message,$sent); return(false);
                }
            
            /** [ METHOD: LOG ACTIVITY ] */
            globals::logActivity(globals::$lang['log']['cronjob']['m1'],array('count'=>count($file)));    
                
            /** [ RETURN: BOOLEAN ] */ 
            unset($file,$tokens,$message); return(true);
            }
            
        /** [ METHOD: LOAD TEMPLATE ] */
        private function loadTemplate($filename,$tokens)
            {
            /** [ OBJECT: TEMPLATES ] */
            $obj=$this->importClass(2);
            $obj->setFileName($filename);
            $obj->setTokens($tokens);
            $xhtml=$obj->getTemplate();
            
            /** [ RETURN: XHTML ] */
            unset($obj); return($xhtml);
            }            
        }
?>